<template>
  <button
    class="flex items-center hover:bg-red-600 bg-red-700 pl-3 pr-4 py-2 rounded"
    :disabled="loading"
    @click="onClick"
  >
    <Spinner v-if="loading" :size="24" />
    <svg v-else style="width: 24px; height: 24px" viewBox="0 0 24 24">
      <path fill="currentColor" d="M18,18H6V6H18V18Z" />
    </svg>
    Stop
  </button>
</template>

<script lang="ts" setup>
import axios from "axios";
import { ref } from "vue";

const props = defineProps(["id"]);

const emit = defineEmits(["error", "click"]);

const loading = ref(false);

const onClick = async function () {
  loading.value = true;

  emit("click");

  try {
    await axios.delete(`${window.origin}/api/jobs/${props.id}`);
  } catch (error) {
    emit("error", error);
  }

  loading.value = false;
};
</script>
